void debug_status(void);

//	#define	TRACE

#ifdef TRACE

void tracelog_start(void);
void tracelog_end(void);
void pcwatch(void);
void trace_inport(WORD a);
void trace_inport_a(WORD a);
void trace_outport(WORD a, BYTE b);
void outstrbyte(BYTE *str, WORD val);
void outstrbytel(BYTE *str, long val);

#define	TRACE_START()		tracelog_start()
#define	TRACE_END()			tracelog_end()
#define	TRACE1()			pcwatch()
#define	TRACEIN(a)			trace_inport(a)
#define	TRACEIN_A(a,b)		trace_inport_a(a,b)
#define	TRACEOUT(a,b)		trace_outport(a,b)
#define	TRACE_(a,b)			outstrbyte(a,b)
#define	TRACEL(a,b)			outstrbytel(a,b)

#else

#define	TRACE_START()		;
#define	TRACE_END()			;
#define	TRACE1()			;
#define	TRACEIN(a)			;
#define	TRACEIN_A(a,b)		;
#define	TRACEOUT(a,b)		;
#define	TRACE_(a,b)			;
#define	TRACEL(a,b)			;

#endif
